/*
 * This software is the confidential and proprietary information of
 * Smardec. You shall not disclose or distribute such Confidential Information.
 * This software shall not be integrated, copied (partially or fully),
 * or reverse engineered into any other software, program, or code that is
 * not intended for Smardec. You shall use it only in accordance with the terms
 * of the license agreement you entered into with Smardec.
 *
 * Copyright (C) 2004-2006 Smardec. All rights reserved.
 *
 * http://www.smardec.com
 *
 */

package com.smardec.demo.j2native.demos;

import com.smardec.demo.j2native.DemoableAdapter;
import com.smardec.demo.j2native.Util;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import java.awt.*;
import java.util.Vector;

public class ContentDemo extends DemoableAdapter {
    public final static String CONSTRAINT_CONTENTS = "Contents";
    public final static String CAPTION_CONTENTS = "Contents";
    private final String INTRO_CONTENTS = "<html><head>" + css + "</head><body>" +
            "<p color=black>J2Native library demo program consists of several parts. Each part is a completed application, written for a definite operating system. At the moment there are 2 such systems  Windows and Linux. In the demo copy you will be able to see the way J2Native is used for the access to the system resources, code sample and operation efficiency partially described." +
            "<br><br><b>Windows Demo:</b>" +
            "<br>The demo program for Windows operating system consists of three independent subprograms:" +
            "<table cellspacing=0 cellpadding=0 border=0>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>1</td><td valign=top color=black>&nbsp;</td><td valign=top color=black><b>Simple Windows API invocation</b></td></tr>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>Two simple API functions <i>MessageBeep()</i> and <i>MessageBox()</i> are taken as examples. You have a possibility to specify parameters for the invocation of the functions.</td></tr>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>2</td><td valign=top color=black>&nbsp;</td><td valign=top color=black><b>Registry Viewer</b></td></tr>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>The program downloads data from Windows registry. (NOTE: program is working in Read-Only mode. No changes will be made under any circumstances.) The program demonstrates you the possibilities you may have while working with the registry when using J2Native library.</td></tr>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>3</td><td valign=top color=black>&nbsp;</td><td valign=top color=black><b>CD Player</b></td></tr>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>One more CD player. The only difference is that its written in pure Java and uses J2Native to create windows of various shapes, to work with system tray and to have an access to Windows Multimedia API.</td></tr>" +
            "</table>" +
            "<br><br><b>Linux/Solaris Demo:</b>" +
            "<br>The demo program for Linux operating system consists of only one subprogram:" +
            "<table cellspacing=0 cellpadding=0 border=0>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>1</td><td valign=top color=black>&nbsp;</td><td valign=top color=black><b>User Viewer</b></td></tr>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>The program reflects information about the system users and its registered groups. To get an access to such information system API is used which is available thanks to J2Native library.</td></tr>" +
            "</table>" +
            "</p>" +
            "</body></html>";

    private JPanel jPanelOptions = null;
    private JPanel jPanelDesc = null;

    public String getID() {
        return CONSTRAINT_CONTENTS;
    }

    public String getCaption() {
        return CAPTION_CONTENTS;
    }

    public Vector getContentDescriptions() {
        return null;
    }

    public int getState() {
        return STATE_NONE;
    }

    public JPanel getDemoPanel() {
        JPanel jPanelContents = new JPanel(new GridBagLayout());
        TitledBorder titledBorder = BorderFactory.createTitledBorder(CAPTION_CONTENTS);
        titledBorder.setTitleColor(Color.black);
        jPanelContents.setBorder(titledBorder);
        JEditorPane jEditorPane = new JEditorPane("text/html", INTRO_CONTENTS);
        jEditorPane.setEditable(false);
        jEditorPane.setCaretPosition(0);
        jEditorPane.setBackground(jPanelContents.getBackground());
        Util.constrain(jPanelContents, new JScrollPane(jEditorPane),
                0, 0, 1, 1, GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST, 1, 1,
                0, 5, 0, 5);

        return jPanelContents;
    }

    public JPanel getOptionPanel() {
        if (jPanelOptions != null)
            return jPanelOptions;
        return null;
    }

    public JPanel getDescriptionPanel() {
        if (jPanelDesc != null)
            return jPanelDesc;
        return null;
    }
}
